import java.util.Comparator;

public class QuickSort implements Sorter {
  private static final boolean DEBUGGING = false;
  public void sort(Comparable[] data) {
    userArray = data;
    if(userArray.length<=0 || isAlreadySorted())
      return;
    quicksort(0, userArray.length - 1);
    if(isAlreadySorted())
      return;
    if(DEBUGGING) {
      // debug ensure sort is working
      if (!isAlreadySorted())
        System.out.println("Sort failed");
    }
    return;
  } // end sort
  // recursive quicksort that breaks array up into sub
  // arrays and sorts each of them.
  private void quicksort(int p, int r) {
    if (p < r) {
      int q = partition(p, r);
      if (q == r) {
        q--;
      }
      quicksort(p, q);
      quicksort(q + 1, r);
    } // end if
  } // end quicksort
  // Partition by splitting this chunk to sort in two and
  // get all big elements on one side of the pivot and all
  // the small elements on the other.
  private int partition(int lo, int hi) {
    Comparable pivot = userArray[lo];
    while (true) {
      while (userArray[hi].compareTo(pivot) >= 0 && lo < hi) {
        hi--;
      }
      while (userArray[lo].compareTo(pivot) < 0 && lo < hi) {
        lo++;
      }
      if (lo < hi) {
        // exchange objects on either side of the pivot
        Comparable T = userArray[lo];
        userArray[lo] = userArray[hi];
        userArray[hi] = T;
      } else
        return hi;
    } // end while
  } // end partition
  // check if user's array is already sorted
  private boolean isAlreadySorted() {
    for (int i = 1; i < userArray.length; i++) {
      if (userArray[i].compareTo(userArray[i - 1]) < 0)
        return false;
    }
    return true;
  } // end isAlreadySorted
  private Comparable[] userArray;
} // end class QuickSort

